﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class EnemyShip : MonoBehaviour {

    public float amplitude;
    public float frequency;
    private float _frequency;
    private float phase = 0.0f;
    float time = 0f;
    public float speed;

    float timer = 0;

    float baseX;
    float baseY;
    float offsetX;
    float offsetY;
    public float horMoveSpeed;
    public float frequencyShiftSpeed;
    public float offsetXLeftLimit;
    public float offsetXRightLimit;
    public float minFrequency;
    public float maxFrequency;

    public Projectile laser;

    public float health;

    public bool swapMovementDirections;
    public float minY;
    public float maxY;
    float xPos;
    float yPos;

    public bool firing;
    public Transform[] firingPositions;
    public float reloadTime;
    public float reloadTimer;

    public Transform cameraMid;
    public float xBuffer;

    public bool Boss;
    public float playerSpeed;

    public bool moveDisable;

    public float touchDamage;

    ScoreCounter scoreCounter;
    public int scoreAdd;

    AudioSource audioSource;

    // Use this for initialization
    void Start()
    {
        scoreCounter = FindObjectOfType<ScoreCounter>();
        _frequency = frequency;
        baseX = transform.position.x;
        baseY = transform.position.y;
        xPos = baseX;
        yPos = baseY;
        audioSource = GetComponent<AudioSource>();
    }

    // Update is called once per frame
    void Update()
    {
        if ((transform.position.x - cameraMid.position.x) <= 9+xBuffer && !moveDisable)
        {
            timer += Time.deltaTime;

            if (frequency != _frequency)
                CalcNewFreq();

            if (!swapMovementDirections)
            {
                yPos = baseY + Mathf.Sin(timer * _frequency + phase) * amplitude;
                xPos = xPos + (speed * Time.deltaTime);
                transform.position = new Vector2(xPos, yPos);
            }
            else
            {
                xPos = baseX + Mathf.Sin(timer * _frequency + phase) * amplitude;
                yPos = +speed * Time.deltaTime;
                transform.position = new Vector2(xPos, yPos);

                //if ((transform.position.y > maxY && speed > 0) || (transform.position.y < minY && speed < 0))
                //{
                //    speed *= -1;
                //}
            }

            reloadTimer -= Time.deltaTime;

            if (firing && reloadTimer <= 0)
            {
                foreach (Transform pos in firingPositions)
                {
                    Projectile shoot = Instantiate(laser);
                    shoot.transform.position = pos.position;
                    shoot.setInitialPos(pos.position.x, pos.position.y);
                }

                audioSource.Play();
                reloadTimer = reloadTime;
            }
        } else if ((transform.position.x - cameraMid.position.x) <= 9 + xBuffer && moveDisable)
        {
            reloadTimer -= Time.deltaTime;

            if (firing && reloadTimer <= 0)
            {
                foreach (Transform pos in firingPositions)
                {
                    Projectile shoot = Instantiate(laser);
                    shoot.transform.position = pos.position;
                    shoot.setInitialPos(pos.position.x, pos.position.y);
                }

                audioSource.Play();
                reloadTimer = reloadTime;
            }
        }
        if ((transform.position.x - cameraMid.position.x) <= 6.7 && !moveDisable)
        {
            speed = playerSpeed;
        }
    }

    void CalcNewFreq()
    {
        float curr = (Time.time * _frequency + phase) % (2.0f * Mathf.PI);
        float next = (Time.time * frequency) % (2.0f * Mathf.PI);
        phase = curr - next;
        _frequency = frequency;
    }

    public void TakeDamage(float damage)
    {
        health -= damage;
        if (health < 0)
        {
            //Destroy(transform.gameObject);
            scoreCounter.score += scoreAdd;
            transform.gameObject.SetActive(false);
        }
    }

    void OnCollisionEnter2D(Collision2D coll)
    {
        if (coll.gameObject.tag == "Player")
        {
            Debug.Log(coll);
            coll.transform.GetComponent<PlayerShip>().TakeDamage(touchDamage);
        }

    }
}
