﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Projectile : MonoBehaviour {

    public float amplitude;
    public float frequency;
    private float _frequency;
    private float phase = 0.0f;
    float time = 0f;
    public float speed;

    float timer = 0;

    float baseX;
    float baseY;
    public GameObject visualObject;
    public GameObject powerupVisual;
    public ParticleSystem hitSpawn;
    public string targetTag;

    public float damage;

    AudioSource audioSource;

    // Use this for initialization
    void Start()
    {
        _frequency = frequency;
        baseX = transform.position.x;
        baseY = transform.position.y;
        audioSource = GetComponent<AudioSource>();
    }

    // Update is called once per frame
    void Update()
    {
        if (damage == 4)
        {
            powerupVisual.gameObject.SetActive(true);
        } else
        {
            powerupVisual.gameObject.SetActive(false);
        }

        timer += Time.deltaTime;
        if (frequency != _frequency)
            CalcNewFreq();

        float yPos = baseY + Mathf.Sin(timer * _frequency + phase) * amplitude;
        float xPos = baseX + (timer * speed);

        transform.position = new Vector2(xPos, yPos);
    }

    void CalcNewFreq()
    {
        float curr = (Time.time * _frequency + phase) % (2.0f * Mathf.PI);
        float next = (Time.time * frequency) % (2.0f * Mathf.PI);
        phase = curr - next;
        _frequency = frequency;
    }

    public void setInitialPos(float x, float y)
    {
        baseX = x;
        baseY = y;
    }

    void OnCollisionEnter2D(Collision2D coll)
    {
        if (coll.gameObject.tag == "Enemy" && targetTag == "Enemy") {
            Debug.Log(coll);
            coll.transform.GetComponent<EnemyShip>().TakeDamage(damage);

            ParticleSystem clone = Instantiate(hitSpawn);
            clone.transform.position = transform.position;
            Destroy(transform.gameObject);
        }

        if (coll.gameObject.tag == "Player" && targetTag == "Player")
        {
            Debug.Log(coll);
            coll.transform.GetComponent<PlayerShip>().TakeDamage(damage);

            ParticleSystem clone = Instantiate(hitSpawn);
            clone.transform.position = transform.position;
            Destroy(transform.gameObject);
        }

    }
}
