﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class UI_Display : MonoBehaviour {

    public PlayerShip player;
    public ScoreCounter score;
    public EnemyShip boss;

    public Text livesCounter;
    public Text healthCounter;
    public Text scoreCounter;
    public Text gameOverText;
    public Text levelCompleteText;

    public SceneChange sceneChanger;
    public bool sceneShift;
    public float sceneTimer = 5;

	// Use this for initialization
	void Start () {
        sceneChanger = GetComponent<SceneChange>();
	}
	
	// Update is called once per frame
	void Update () {
        livesCounter.text = "X " + player.lives;
        healthCounter.text = "Health: " + player.health;
        scoreCounter.text = "Score: " + score.score;

        if (player.lives < 0)
        {
            gameOverText.gameObject.SetActive(true);
            player.gameObject.SetActive(false);
            livesCounter.text = "X 0";
            sceneShift = true; 
        }

        if (boss.health < 0)
        {
            levelCompleteText.gameObject.SetActive(true);
            sceneShift = true;
        }

        if (sceneShift)
        {
            sceneTimer -= Time.deltaTime;

            if (sceneTimer <= 0)
            {
                sceneChanger.TitleScreen();
            }
        }
    }
}
