﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
[RequireComponent(typeof(LineRenderer))]
//Author: Hayden Munday.
//Description: Attempting to draw sin wave visualization using a line renderer.

public class WaveDrawerLineRenderer : MonoBehaviour {

    public int numOfVerts = 0;
    public float xOffset = 0.4f;

    private LineRenderer LR;
    private float baseY, baseX;

    public PlayerShip ship;

	// Use this for initialization
	void Start () {
        ship = GetComponent<PlayerShip>();
        LR = GetComponent<LineRenderer>();
        lineInit();
        
    }

    //setup the line
    void lineInit() {
        LR.numPositions = numOfVerts;
        for (int i = 0; i < numOfVerts; i++) {
            LR.SetPosition(i, new Vector3(xOffset * i, 0, 0));
        }

    }
	
	// Update is called once per frame
	void Update () {
        baseY = transform.position.y;
        baseX = transform.position.x;
        reCalcWave();
	}

    void reCalcWave() {
        PlayerShip PS = GetComponent<PlayerShip>();
        float Phase = PS.GetPhase();
        for (int i = 0; i < numOfVerts; i++) {
            float y = Mathf.Sin(ship.timer * PS.GetFrequency() + Phase + (xOffset * i)) * PS.amplitude;
            LR.SetPosition(i, new Vector3((baseX - PS.GetFrequency() * PS.amplitude * 1.6f) + xOffset * i * PS.GetFrequency(), y, 0));
        }
    }
}
